Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 515)
@@ -20,4 +20,10 @@
 #define __PJSUA_H__
 
+/**
+ * @file pjsua.h
+ * @brief PJSUA API.
+ */
+
+
 /* Include all PJSIP core headers. */
 #include <pjsip.h>
@@ -42,37 +48,149 @@
 
 
+/**
+ * @defgroup PJSUA_LIB PJSUA API
+ * @ingroup PJSIP
+ * @brief Very high level API for constructing SIP UA applications.
+ * @{
+ *
+ * PJSUA API is very high level API for constructing SIP user agent
+ * applications. It wraps together the signaling and media functionalities
+ * into an easy to use call API, provides account management, buddy
+ * management, presence, instant messaging, along with multimedia
+ * features such as conferencing, file streaming, local playback,
+ * voice recording, and so on.
+ *
+ * Application must link with <b>pjsua-lib</b> to use this API. In addition,
+ * this library depends on the following libraries:
+ *  - <b>pjsip-ua</b>, 
+ *  - <b>pjsip-simple</b>, 
+ *  - <b>pjsip-core</b>, 
+ *  - <b>pjmedia</b>,
+ *  - <b>pjmedia-codec</b>, 
+ *  - <b>pjlib-util</b>, and
+ *  - <b>pjlib</b>, 
+ *
+ * so application must also link with these libraries as well.
+ *
+ * @section root_using_pjsua_lib Using PJSUA API
+ *
+ * Please refer to @ref using_pjsua_lib on how to use PJSUA API.
+ */ 
+
 PJ_BEGIN_DECL
 
 
-/**
- * Max buddies in buddy list.
- */
-#ifndef PJSUA_MAX_BUDDIES
-#   define PJSUA_MAX_BUDDIES	    256
-#endif
-
-
-/**
- * Max simultaneous calls.
- */
-#ifndef PJSUA_MAX_CALLS
-#   define PJSUA_MAX_CALLS	    32
-#endif
-
-
-/**
- * Max ports in the conference bridge.
- */
-#ifndef PJSUA_MAX_CONF_PORTS
-#   define PJSUA_MAX_CONF_PORTS	    254
-#endif
-
-
-/**
- * Maximum accounts.
- */
-#ifndef PJSUA_MAX_ACC
-#   define PJSUA_MAX_ACC	    8
-#endif
+/** Forward declaration */
+typedef struct pjsua_media_config pjsua_media_config;
+
+
+/*****************************************************************************
+ * BASE API
+ */
+
+/**
+ * @defgroup PJSUA_LIB_BASE Base API
+ * @ingroup PJSUA_LIB
+ * @brief Basic application creation/initialization, logging configuration, etc.
+ * @{
+ *
+ * The base PJSUA API controls PJSUA creation, initialization, and startup, and
+ * also provides various auxiliary functions.
+ *
+ * @section using_pjsua_lib Using PJSUA Library
+ *
+ * @subsection creating_pjsua_lib Creating PJSUA
+ *
+ * Before anything else, application must create PJSUA by calling #pjsua_create().
+ * This, among other things, will initialize PJLIB, which is crucial before 
+ * any PJLIB functions can be called.
+ *
+ * @subsection init_pjsua_lib Initializing PJSUA
+ *
+ * After PJSUA is created, application can initialize PJSUA by calling
+ * #pjsua_init(). This function takes several configuration settings in the
+ * argument, so application normally would want to set these configuration
+ * before passing them to #pjsua_init().
+ *
+ * Sample code to initialize PJSUA:
+ \code
+
+    pjsua_config	 ua_cfg;
+    pjsua_logging_config log_cfg;
+    pjsua_media_config   media_cfg;
+
+    // Initialize configs with default settings.
+    pjsua_config_default(&ua_cfg);
+    pjsua_logging_config_default(&log_cfg);
+    pjsua_media_config_default(&media_cfg);
+
+    // At the very least, application would want to override
+    // the call callbacks in pjsua_config:
+    ua_cfg.cb.on_incoming_call = ...
+    ua_cfg.cb.on_call_state = ..
+    ...
+
+    // Customize other settings (or initialize them from application specific
+    // configuration file):
+    ...
+
+    // Initialize pjsua
+    status = pjsua_init(&ua_cfg, &log_cfg, &media_cfg);
+    if (status != PJ_SUCCESS) {
+          pjsua_perror(THIS_FILE, "Error initializing pjsua", status);
+	  return status;
+    }
+    ..
+
+ \endcode
+ *
+ * @subsection other_init_pjsua_lib Other Initialization
+ *
+ * After PJSUA is initialized with #pjsua_init(), application will normally
+ * need/want to perform the following tasks:
+ *
+ *  - create SIP transport with #pjsua_transport_create(). Please see
+ *    @ref PJSUA_LIB_TRANSPORT section for more info.
+ *  - create one or more SIP accounts with #pjsua_acc_add() or
+ *    #pjsua_acc_add_local(). Please see @ref PJSUA_LIB_ACC for more info.
+ *  - add one or more buddies with #pjsua_buddy_add(). Please see
+ *    @ref PJSUA_LIB_BUDDY section for more info.
+ *  - optionally configure the sound device, codec settings, and other
+ *    media settings. Please see @ref PJSUA_LIB_MEDIA for more info.
+ *
+ *
+ * @subsection starting_pjsua_lib Starting PJSUA
+ *
+ * After all initializations have been done, application must call
+ * #pjsua_start() to start PJSUA. This function will check that all settings
+ * are properly configured, and apply default settings when it's not, or
+ * report error status when it is unable to recover from missing setting.
+ *
+ * Most settings can be changed during run-time. For example, application
+ * may add, modify, or delete accounts, buddies, or change media settings
+ * during run-time.
+ */
+
+/** Constant to identify invalid ID for all sorts of IDs. */
+#define PJSUA_INVALID_ID	    (-1)
+
+/** Call identification */
+typedef int pjsua_call_id;
+
+/** Account identification */
+typedef int pjsua_acc_id;
+
+/** Buddy identification */
+typedef int pjsua_buddy_id;
+
+/** File player identification */
+typedef int pjsua_player_id;
+
+/** File recorder identification */
+typedef int pjsua_recorder_id;
+
+/** Conference port identification */
+typedef int pjsua_conf_port_id;
+
 
 
@@ -83,429 +201,4 @@
 #   define PJSUA_ACC_MAX_PROXIES    8
 #endif
-
-/**
- * Default registration interval.
- */
-#ifndef PJSUA_REG_INTERVAL
-#   define PJSUA_REG_INTERVAL	    55
-#endif
-
-
-/** Account identification */
-typedef int pjsua_acc_id;
-
-/** Call identification */
-typedef int pjsua_call_id;
-
-/** SIP transport identification */
-typedef int pjsua_transport_id;
-
-/** Buddy identification */
-typedef int pjsua_buddy_id;
-
-/** File player identification */
-typedef int pjsua_player_id;
-
-/** File recorder identification */
-typedef int pjsua_recorder_id;
-
-/** Conference port identification */
-typedef int pjsua_conf_port_id;
-
-
-/** Constant to identify invalid ID for all sorts of IDs. */
-#define PJSUA_INVALID_ID	    (-1)
-
-
-
-/**
- * Account configuration.
- */
-typedef struct pjsua_acc_config
-{
-    /** 
-     * The full SIP URL for the account. The value can take name address or 
-     * URL format, and will look something like "sip:account@serviceprovider".
-     *
-     * This field is mandatory.
-     */
-    pj_str_t	    id;
-
-    /** 
-     * This is the URL to be put in the request URI for the registration,
-     * and will look something like "sip:serviceprovider".
-     *
-     * This field should be specified if registration is desired. If the
-     * value is empty, no account registration will be performed.
-     */
-    pj_str_t	    reg_uri;
-
-    /** 
-     * Optional URI to be put as Contact for this account. It is recommended
-     * that this field is left empty, so that the value will be calculated
-     * automatically based on the transport address.
-     */
-    pj_str_t	    contact;
-
-    /**
-     * Number of proxies in the proxy array below.
-     */
-    unsigned	    proxy_cnt;
-
-    /** 
-     * Optional URI of the proxies to be visited for all outgoing requests 
-     * that are using this account (REGISTER, INVITE, etc). Application need 
-     * to specify these proxies if the service provider requires that requests
-     * destined towards its network should go through certain proxies first
-     * (for example, border controllers).
-     *
-     * These proxies will be put in the route set for this account, with 
-     * maintaining the orders (the first proxy in the array will be visited
-     * first).
-     */
-    pj_str_t	    proxy[PJSUA_ACC_MAX_PROXIES];
-
-    /** 
-     * Optional interval for registration, in seconds. If the value is zero, 
-     * default interval will be used (PJSUA_REG_INTERVAL, 55 seconds).
-     */
-    unsigned	    reg_timeout;
-
-    /** 
-     * Number of credentials in the credential array.
-     */
-    unsigned	    cred_count;
-
-    /** 
-     * Array of credentials. If registration is desired, normally there should
-     * be at least one credential specified, to successfully authenticate
-     * against the service provider. More credentials can be specified, for
-     * example when the requests are expected to be challenged by the
-     * proxies in the route set.
-     */
-    pjsip_cred_info cred_info[PJSUA_ACC_MAX_PROXIES];
-
-} pjsua_acc_config;
-
-
-/**
- * Call this function to initialize account config with default values.
- *
- * @param cfg	    The account config to be initialized.
- */
-PJ_INLINE(void) pjsua_acc_config_default(pjsua_acc_config *cfg)
-{
-    pj_memset(cfg, 0, sizeof(*cfg));
-
-    cfg->reg_timeout = PJSUA_REG_INTERVAL;
-}
-
-
-
-/**
- * Account info. Application can query account info by calling 
- * #pjsua_acc_get_info().
- */
-typedef struct pjsua_acc_info
-{
-    /** 
-     * The account ID. 
-     */
-    pjsua_acc_id	id;
-
-    /**
-     * Flag to indicate whether this is the default account.
-     */
-    pj_bool_t		is_default;
-
-    /** 
-     * Account URI 
-     */
-    pj_str_t		acc_uri;
-
-    /** 
-     * Flag to tell whether this account has registration setting
-     * (reg_uri is not empty).
-     */
-    pj_bool_t		has_registration;
-
-    /**
-     * An up to date expiration interval for account registration session.
-     */
-    int			expires;
-
-    /**
-     * Last registration status code. If status code is zero, the account
-     * is currently not registered. Any other value indicates the SIP
-     * status code of the registration.
-     */
-    pjsip_status_code	status;
-
-    /**
-     * String describing the registration status.
-     */
-    pj_str_t		status_text;
-
-    /**
-     * Presence online status for this account.
-     */
-    pj_bool_t		online_status;
-
-    /**
-     * Buffer that is used internally to store the status text.
-     */
-    char		buf_[PJ_ERR_MSG_SIZE];
-
-} pjsua_acc_info;
-
-
-
-/**
- * STUN configuration.
- */
-typedef struct pjsua_stun_config
-{
-    /**
-     * The first STUN server IP address or hostname.
-     */
-    pj_str_t	stun_srv1;
-
-    /**
-     * Port number of the first STUN server.
-     * If zero, default STUN port will be used.
-     */
-    unsigned	stun_port1;
-    
-    /**
-     * Optional second STUN server IP address or hostname, for which the
-     * result of the mapping request will be compared to. If the value
-     * is empty, only one STUN server will be used.
-     */
-    pj_str_t	stun_srv2;
-
-    /**
-     * Port number of the second STUN server.
-     * If zero, default STUN port will be used.
-     */
-    unsigned	stun_port2;
-
-} pjsua_stun_config;
-
-
-
-/**
- * Call this function to initialize STUN config with default values.
- *
- * @param cfg	    The STUN config to be initialized.
- */
-PJ_INLINE(void) pjsua_stun_config_default(pjsua_stun_config *cfg)
-{
-    pj_memset(cfg, 0, sizeof(*cfg));
-}
-
-
-/**
- * Transport configuration for creating UDP transports for both SIP
- * and media.
- */
-typedef struct pjsua_transport_config
-{
-    /**
-     * UDP port number to bind locally. This setting MUST be specified
-     * even when default port is desired. If the value is zero, the
-     * transport will be bound to any available port, and application
-     * can query the port by querying the transport info.
-     */
-    unsigned		port;
-
-    /**
-     * Optional address where the socket should be bound.
-     */
-    pj_in_addr		ip_addr;
-
-    /**
-     * Flag to indicate whether STUN should be used.
-     */
-    pj_bool_t		use_stun;
-
-    /**
-     * STUN configuration, must be specified when STUN is used.
-     */
-    pjsua_stun_config	stun_config;
-
-} pjsua_transport_config;
-
-
-/**
- * Call this function to initialize UDP config with default values.
- *
- * @param cfg	    The UDP config to be initialized.
- */
-PJ_INLINE(void) pjsua_transport_config_default(pjsua_transport_config *cfg)
-{
-    pj_memset(cfg, 0, sizeof(*cfg));
-}
-
-
-/**
- * Normalize STUN config.
- */
-PJ_INLINE(void) pjsua_normalize_stun_config( pjsua_stun_config *cfg )
-{
-    if (cfg->stun_srv1.slen) {
-
-	if (cfg->stun_port1 == 0)
-	    cfg->stun_port1 = 3478;
-
-	if (cfg->stun_srv2.slen == 0) {
-	    cfg->stun_srv2 = cfg->stun_srv1;
-	    cfg->stun_port2 = cfg->stun_port1;
-	} else {
-	    if (cfg->stun_port2 == 0)
-		cfg->stun_port2 = 3478;
-	}
-
-    } else {
-	cfg->stun_port1 = 0;
-	cfg->stun_srv2.slen = 0;
-	cfg->stun_port2 = 0;
-    }
-}
-
-
-/**
- * Duplicate transport config.
- */
-PJ_INLINE(void) pjsua_transport_config_dup(pj_pool_t *pool,
-					   pjsua_transport_config *dst,
-					   const pjsua_transport_config *src)
-{
-    pj_memcpy(dst, src, sizeof(*src));
-
-    if (src->stun_config.stun_srv1.slen) {
-	pj_strdup_with_null(pool, &dst->stun_config.stun_srv1,
-			    &src->stun_config.stun_srv1);
-    }
-
-    if (src->stun_config.stun_srv2.slen) {
-	pj_strdup_with_null(pool, &dst->stun_config.stun_srv2,
-			    &src->stun_config.stun_srv2);
-    }
-
-    pjsua_normalize_stun_config(&dst->stun_config);
-}
-
-
-
-/**
- * Transport info.
- */
-typedef struct pjsua_transport_info
-{
-    /**
-     * PJSUA transport identification.
-     */
-    pjsua_transport_id	    id;
-
-    /**
-     * Transport type.
-     */
-    pjsip_transport_type_e  type;
-
-    /**
-     * Transport type name.
-     */
-    pj_str_t		    type_name;
-
-    /**
-     * Transport string info/description.
-     */
-    pj_str_t		    info;
-
-    /**
-     * Transport flag (see ##pjsip_transport_flags_e).
-     */
-    unsigned		    flag;
-
-    /**
-     * Local address length.
-     */
-    unsigned		    addr_len;
-
-    /**
-     * Local/bound address.
-     */
-    pj_sockaddr		    local_addr;
-
-    /**
-     * Published address (or transport address name).
-     */
-    pjsip_host_port	    local_name;
-
-    /**
-     * Current number of objects currently referencing this transport.
-     */
-    unsigned		    usage_count;
-
-
-} pjsua_transport_info;
-
-
-/**
- * Media configuration.
- */
-typedef struct pjsua_media_config
-{
-    /**
-     * Clock rate to be applied to the conference bridge.
-     * If value is zero, default clock rate will be used (16KHz).
-     */
-    unsigned		clock_rate;
-
-    /**
-     * Specify maximum number of media ports to be created in the
-     * conference bridge. Since all media terminate in the bridge
-     * (calls, file player, file recorder, etc), the value must be
-     * large enough to support all of them. However, the larger
-     * the value, the more computations are performed.
-     */
-    unsigned		max_media_ports;
-
-    /**
-     * Specify whether the media manager should manage its own
-     * ioqueue for the RTP/RTCP sockets. If yes, ioqueue will be created
-     * and at least one worker thread will be created too. If no,
-     * the RTP/RTCP sockets will share the same ioqueue as SIP sockets,
-     * and no worker thread is needed.
-     *
-     * Normally application would say yes here, unless it wants to
-     * run everything from a single thread.
-     */
-    pj_bool_t		has_ioqueue;
-
-    /**
-     * Specify the number of worker threads to handle incoming RTP
-     * packets. A value of one is recommended for most applications.
-     */
-    unsigned		thread_cnt;
-
-
-} pjsua_media_config;
-
-
-/**
- * Use this function to initialize media config.
- *
- * @param cfg	The media config to be initialized.
- */
-PJ_INLINE(void) pjsua_media_config_default(pjsua_media_config *cfg)
-{
-    pj_memset(cfg, 0, sizeof(*cfg));
-
-    cfg->clock_rate = 16000;
-    cfg->max_media_ports = 32;
-    cfg->has_ioqueue = PJ_TRUE;
-    cfg->thread_cnt = 1;
-}
 
 
@@ -583,114 +276,4 @@
 }
 
-
-/**
- * Buddy configuration.
- */
-typedef struct pjsua_buddy_config
-{
-    /**
-     * Buddy URL or name address.
-     */
-    pj_str_t	uri;
-
-    /**
-     * Specify whether presence subscription should start immediately.
-     */
-    pj_bool_t	subscribe;
-
-} pjsua_buddy_config;
-
-
-/**
- * Buddy's online status.
- */
-typedef enum pjsua_buddy_status
-{
-    /**
-     * Online status is unknown (possibly because no presence subscription
-     * has been established).
-     */
-    PJSUA_BUDDY_STATUS_UNKNOWN,
-
-    /**
-     * Buddy is known to be offline.
-     */
-    PJSUA_BUDDY_STATUS_ONLINE,
-
-    /**
-     * Buddy is offline.
-     */
-    PJSUA_BUDDY_STATUS_OFFLINE,
-
-} pjsua_buddy_status;
-
-
-
-/**
- * Buddy info.
- */
-typedef struct pjsua_buddy_info
-{
-    /**
-     * The buddy ID.
-     */
-    pjsua_buddy_id	id;
-
-    /**
-     * The full URI of the buddy, as specified in the configuration.
-     */
-    pj_str_t		uri;
-
-    /**
-     * Buddy's Contact, only available when presence subscription has
-     * been established to the buddy.
-     */
-    pj_str_t		contact;
-
-    /**
-     * Buddy's online status.
-     */
-    pjsua_buddy_status	status;
-
-    /**
-     * Text to describe buddy's online status.
-     */
-    pj_str_t		status_text;
-
-    /**
-     * Flag to indicate that we should monitor the presence information for
-     * this buddy (normally yes, unless explicitly disabled).
-     */
-    pj_bool_t		monitor_pres;
-
-    /**
-     * Internal buffer.
-     */
-    char		buf_[256];
-
-} pjsua_buddy_info;
-
-
-/**
- * Codec config.
- */
-typedef struct pjsua_codec_info
-{
-    /**
-     * Codec unique identification.
-     */
-    pj_str_t		codec_id;
-
-    /**
-     * Codec priority (integer 0-255).
-     */
-    pj_uint8_t		priority;
-
-    /**
-     * Internal buffer.
-     */
-    char		buf_[32];
-
-} pjsua_codec_info;
 
 
